LeetCode 1387. Sort Integers by The Power Value

原题链接在这里:https://leetcode.com/problems/sort-integers-by-the-power-value/description/

题目:

The power of an integer x is defined as the number of steps needed to transform x into 1 using the following steps:

  • if x is even then x = x / 2
  • if x is odd then x = 3 * x + 1

For example, the power of x = 3 is 7 because 3 needs 7 steps to become 1 (3 --> 10 --> 5 --> 16 --> 8 --> 4 --> 2 --> 1).

Given three integers lohi and k. The task is to sort all integers in the interval [lo, hi] by the power value in ascending order, if two or more integers have the same power value sort them by ascending order.

Return the kth integer in the range [lo, hi] sorted by the power value.

Notice that for any integer x (lo <= x <= hi) it is guaranteed that x will transform into 1 using these steps and that the power of x is will fit in a 32-bit signed integer.

Example 1:

Input: lo = 12, hi = 15, k = 2
Output: 13
Explanation: The power of 12 is 9 (12 --> 6 --> 3 --> 10 --> 5 --> 16 --> 8 --> 4 --> 2 --> 1)
The power of 13 is 9
The power of 14 is 17
The power of 15 is 17
The interval sorted by the power value [12,13,14,15]. For k = 2 answer is the second element which is 13.
Notice that 12 and 13 have the same power value and we sorted them in ascending order. Same for 14 and 15.

Example 2:

Input: lo = 7, hi = 11, k = 4
Output: 7
Explanation: The power array corresponding to the interval [7, 8, 9, 10, 11] is [16, 3, 19, 6, 14].
The interval sorted by power is [8, 10, 11, 7, 9].
The fourth number in the sorted array is 7.

Constraints:

  • 1 <= lo <= hi <= 1000
  • 1 <= k <= hi - lo + 1

题解:

We can sort the based on array, array[0] is the original value, array[1] is the power. First sort based on power, then on value.

To get power, we can use DFS + memo. 

Base case is 1, return 0. 

If memo contains it, return the corresponding value.

Otherwise, get the next value using DFS, update the memo and return next + 1.

Time Complexity: O(n(logM + logk)). n = hi - lo. M = maximum value encountered when calculating power. The worst case scenario is when the sequence goes through many odd numbers before reaching 1. Memoization is used. The amortized time for calStep is O(logM).

Space: O(hi + k). memo takes O(hi). minHeap takes O(k).

AC Java:

复制代码
 1 class Solution {
 2     public int getKth(int lo, int hi, int k) {
 3         k = hi - lo + 1 - k + 1;
 4         PriorityQueue<int[]> minHeap = new PriorityQueue<>((a, b) -> a[1] == b[1] ? a[0] - b[0] : a[1] - b[1]);
 5         for(int i = lo; i <= hi; i++){
 6             int[] can = new int[]{i, calStep(i)};
 7             minHeap.add(can);
 8             if(minHeap.size() > k){
 9                 minHeap.poll();
10             }
11         }
12 
13         return minHeap.peek()[0];
14     }
15 
16     Map<Integer, Integer> memo = new HashMap<>();
17     private int calStep(int i){
18         if(i == 1){
19             return 0;
20         }
21 
22         if(memo.containsKey(i)){
23             return memo.get(i);
24         }
25 
26         int next = 0;
27         if(i % 2 == 1){
28             next = calStep(3 * i + 1);
29         }else{
30             next = calStep(i / 2);
31         }   
32 
33         memo.put(i, next + 1);
34         return next + 1;
35     }
36 }
复制代码

 

posted @   Dylan_Java_NYC  阅读(19)  评论(0编辑  收藏  举报
相关博文:
阅读排行:
· 阿里最新开源QwQ-32B,效果媲美deepseek-r1满血版,部署成本又又又降低了!
· 开源Multi-agent AI智能体框架aevatar.ai,欢迎大家贡献代码
· Manus重磅发布:全球首款通用AI代理技术深度解析与实战指南
· 被坑几百块钱后,我竟然真的恢复了删除的微信聊天记录!
· AI技术革命,工作效率10个最佳AI工具
历史上的今天:
2022-08-04 LeetCode 1400. Construct K Palindrome Strings
2022-08-04 LeetCode 1950. Maximum of Minimum Values in All Subarrays
2022-08-04 LeetCode 2187. Minimum Time to Complete Trips
2022-08-04 1438. Longest Continuous Subarray With Absolute Diff Less Than or Equal to Limit
2019-08-04 LeetCode 841. Keys and Rooms
2019-08-04 LeetCode 1061. Lexicographically Smallest Equivalent String
2019-08-04 LeetCode 1102. Path With Maximum Minimum Value
点击右上角即可分享
微信分享提示